HDOJ 1518 Square(DFS 深搜)

题目

Square

Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 3911    Accepted Submission(s): 1302


Problem Description
Given a set of sticks of various lengths, is it possible to join them end-to-end to form a square?


 

Input
The first line of input contains N, the number of test cases. Each test case begins with an integer 4 <= M <= 20, the number of sticks. M integers follow; each gives the length of a stick - an integer between 1 and 10,000.


 

Output
For each case, output a line containing "yes" if is is possible to form a square; otherwise output "no".


 

Sample Input
  
  
3 4 1 1 1 1 5 10 20 30 40 50 8 1 7 2 6 4 4 3 5


 

Sample Output
  
  
yes no yes

 

题目链接

http://acm.hdu.edu.cn/showproblem.php?pid=1518

 

思路:

给出的边要全部用到,将所给的边组成正方形,所有边都要搜到,所以要用到深搜的方法,并且需要剪枝,不然可能会爆,代码是参考别人的,首先要判断所有的边是否能组成正方形,再者就是最终要的DFS,结束条件和递归都是DFS的重要部分,当然这道题需要回溯,因为标记后,如果那种方法不行,回溯才能使下次能搜到这些被标记过但又没有用到的边

 

代码:

#include<iostream>
using namespace  std;

int a[20+10];
bool used[20+10];
int n,m,sum;

int dfs(int d, int w, int count)
{
	if(d == sum)
	{
		w = 0;
		d = 0;//
		count++;
		if(count == 4)
			return 1;
	}

	for(int i=w; i<m; i++)
	{
		if(!used[i])
		{
			used[i] = 1;
			if((d+a[i] <= sum ) && dfs(d+a[i], i+1, count))
				return 1;
			used[i] = 0;
		}
	}
	return 0;
}

int main()
{
	cin>>n;
	while(n--)
	{
		cin>>m;
		sum = 0;
		memset(used, 0, sizeof(used));
		for(int i=0; i<m; i++)
		{
			cin>>a[i];
			sum += a[i];
		}
		int flag = 0;

		if(sum % 4 ==0)
		{
			sum /= 4;
			flag = dfs(0, 0, 0);
		}

		if(flag)
		{
			cout<<"yes"<<endl;
		}
		else 
		{
			cout<<"no"<<endl;
		}
	}
}


 

  • 0
    点赞
  • 2
    收藏
    觉得还不错? 一键收藏
  • 2
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论 2
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值